from typing import TYPE_CHECKING, Any, BinaryIO, Dict, List, Optional, TextIO, Tuple, Type, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="DuplicateDashboardParams")


@_attrs_define
class DuplicateDashboardParams:
    """
    Attributes:
        dashboard_desc (str):
        dashboard_name (str):
    """

    dashboard_desc: str
    dashboard_name: str
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        dashboard_desc = self.dashboard_desc

        dashboard_name = self.dashboard_name

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "dashboardDesc": dashboard_desc,
                "dashboardName": dashboard_name,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        dashboard_desc = d.pop("dashboardDesc")

        dashboard_name = d.pop("dashboardName")

        duplicate_dashboard_params = cls(
            dashboard_desc=dashboard_desc,
            dashboard_name=dashboard_name,
        )

        duplicate_dashboard_params.additional_properties = d
        return duplicate_dashboard_params

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
